diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/examples/olsr-hna.cc ns-3.38/src/olsr/examples/olsr-hna.cc
--- ns-3.37/src/olsr/examples/olsr-hna.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/examples/olsr-hna.cc	2023-03-16 20:54:23.812869000 -0700
@@ -138,7 +138,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents(); // Turn on all Wifi logging
+        WifiHelper::EnableLogComponents(); // Turn on all Wifi logging
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/model/olsr-header.cc ns-3.38/src/olsr/model/olsr-header.cc
--- ns-3.37/src/olsr/model/olsr-header.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/model/olsr-header.cc	2023-03-16 20:54:23.812869000 -0700
@@ -85,7 +85,7 @@
 ///
 /// \brief Converts a number of seconds in the mantissa/exponent format to a decimal number.
 ///
-/// \param olsr_format number of seconds in mantissa/exponent format.
+/// \param olsrFormat number of seconds in mantissa/exponent format.
 /// \return the decimal number of seconds.
 ///
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/model/olsr-repositories.h ns-3.38/src/olsr/model/olsr-repositories.h
--- ns-3.37/src/olsr/model/olsr-repositories.h	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/model/olsr-repositories.h	2023-03-16 20:54:23.812869000 -0700
@@ -102,7 +102,10 @@
     {
         STATUS_NOT_SYM = 0, // "not symmetric"
         STATUS_SYM = 1,     // "symmetric"
-    } status;               //!< Status of the link.
+    };
+
+    /// Status of the link.
+    Status status;
 
     /// A value between 0 and 7 specifying the node's willingness to carry traffic on behalf of
     /// other nodes.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/model/olsr-routing-protocol.cc ns-3.38/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.37/src/olsr/model/olsr-routing-protocol.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/model/olsr-routing-protocol.cc	2023-03-16 20:54:23.812869000 -0700
@@ -248,12 +248,6 @@
     m_hnaRoutingTable->SetIpv4(ipv4);
 }
 
-Ptr<Ipv4>
-RoutingProtocol::GetIpv4() const
-{
-    return m_ipv4;
-}
-
 void
 RoutingProtocol::DoDispose()
 {
@@ -305,7 +299,7 @@
         *os << std::setw(16) << iter->first;
         *os << std::setw(16) << iter->second.nextAddr;
         *os << std::setw(16);
-        if (Names::FindName(m_ipv4->GetNetDevice(iter->second.interface)) != "")
+        if (!Names::FindName(m_ipv4->GetNetDevice(iter->second.interface)).empty())
         {
             *os << Names::FindName(m_ipv4->GetNetDevice(iter->second.interface));
         }
@@ -1889,7 +1883,7 @@
             mid.interfaceAddresses.push_back(addr);
         }
     }
-    if (mid.interfaceAddresses.size() == 0)
+    if (mid.interfaceAddresses.empty())
     {
         return;
     }
@@ -1927,7 +1921,7 @@
         associations.push_back(assoc);
     }
     // If there is no HNA associations to send, return without queuing the message
-    if (associations.size() == 0)
+    if (associations.empty())
     {
         return;
     }
@@ -2671,7 +2665,7 @@
 void
 RoutingProtocol::TcTimerExpire()
 {
-    if (m_state.GetMprSelectors().size() > 0)
+    if (!m_state.GetMprSelectors().empty())
     {
         SendTc();
     }
@@ -2692,7 +2686,7 @@
 void
 RoutingProtocol::HnaTimerExpire()
 {
-    if (m_state.GetAssociations().size() > 0)
+    if (!m_state.GetAssociations().empty())
     {
         SendHna();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/model/olsr-routing-protocol.h ns-3.38/src/olsr/model/olsr-routing-protocol.h
--- ns-3.37/src/olsr/model/olsr-routing-protocol.h	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/model/olsr-routing-protocol.h	2023-03-16 20:54:23.812869000 -0700
@@ -356,11 +356,6 @@
                     ErrorCallback ecb) override;
     void SetIpv4(Ptr<Ipv4> ipv4) override;
 
-    /**
-     * \returns the ipv4 object this routing protocol is associated with
-     */
-    NS_DEPRECATED_3_34
-    virtual Ptr<Ipv4> GetIpv4() const;
     void PrintRoutingTable(Ptr<OutputStreamWrapper> stream,
                            Time::Unit unit = Time::S) const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/olsr/test/olsr-routing-protocol-test-suite.cc ns-3.38/src/olsr/test/olsr-routing-protocol-test-suite.cc
--- ns-3.37/src/olsr/test/olsr-routing-protocol-test-suite.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/olsr/test/olsr-routing-protocol-test-suite.cc	2023-03-16 20:54:23.812869000 -0700
@@ -81,13 +81,13 @@
      *
      * Node 1 must select only one MPR (2 or 3, doesn't matter)
      */
-    NeighborTuple neigbor;
-    neigbor.status = NeighborTuple::STATUS_SYM;
-    neigbor.willingness = OLSR_WILL_DEFAULT;
-    neigbor.neighborMainAddr = Ipv4Address("10.0.0.2");
-    protocol->m_state.InsertNeighborTuple(neigbor);
-    neigbor.neighborMainAddr = Ipv4Address("10.0.0.3");
-    protocol->m_state.InsertNeighborTuple(neigbor);
+    NeighborTuple neighbor;
+    neighbor.status = NeighborTuple::STATUS_SYM;
+    neighbor.willingness = OLSR_WILL_DEFAULT;
+    neighbor.neighborMainAddr = Ipv4Address("10.0.0.2");
+    protocol->m_state.InsertNeighborTuple(neighbor);
+    neighbor.neighborMainAddr = Ipv4Address("10.0.0.3");
+    protocol->m_state.InsertNeighborTuple(neighbor);
     TwoHopNeighborTuple tuple;
     tuple.expirationTime = Seconds(3600);
     tuple.neighborMainAddr = Ipv4Address("10.0.0.2");
@@ -149,9 +149,9 @@
      *
      * Node 1 must select nodes 2, 3 and 7 (since it is WILL_ALWAYS) as MPRs.
      */
-    neigbor.willingness = OLSR_WILL_ALWAYS;
-    neigbor.neighborMainAddr = Ipv4Address("10.0.0.7");
-    protocol->m_state.InsertNeighborTuple(neigbor);
+    neighbor.willingness = OLSR_WILL_ALWAYS;
+    neighbor.neighborMainAddr = Ipv4Address("10.0.0.7");
+    protocol->m_state.InsertNeighborTuple(neighbor);
 
     protocol->MprComputation();
     mpr = state.GetMprSet();
@@ -171,9 +171,9 @@
      * Node 1 must select nodes 2, 3 and 7 (since it is WILL_ALWAYS) as MPRs.
      * Node 1 must NOT select node 8 as MPR since it is WILL_NEVER
      */
-    neigbor.willingness = OLSR_WILL_NEVER;
-    neigbor.neighborMainAddr = Ipv4Address("10.0.0.8");
-    protocol->m_state.InsertNeighborTuple(neigbor);
+    neighbor.willingness = OLSR_WILL_NEVER;
+    neighbor.neighborMainAddr = Ipv4Address("10.0.0.8");
+    protocol->m_state.InsertNeighborTuple(neighbor);
     tuple.neighborMainAddr = Ipv4Address("10.0.0.8");
     tuple.twoHopNeighborAddr = Ipv4Address("10.0.0.9");
     protocol->m_state.InsertTwoHopNeighborTuple(tuple);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/openflow/CMakeLists.txt ns-3.38/src/openflow/CMakeLists.txt
--- ns-3.37/src/openflow/CMakeLists.txt	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/openflow/CMakeLists.txt	2023-03-16 20:54:23.812869000 -0700
@@ -20,6 +20,8 @@
     openflow_FOUND)
    AND (NOT
         ${openflow_FOUND})
+   AND (NOT
+        ${NS3_FETCH_OPTIONAL_COMPONENTS})
 )
   message(
     ${HIGHLIGHTED_STATUS}
@@ -28,6 +30,12 @@
   return()
 endif()
 
+if(${NS3_FETCH_OPTIONAL_COMPONENTS})
+  set(openflow_LIBRARIES
+      openflow
+  )
+endif()
+
 check_include_file_cxx(
   boost/static_assert.hpp
   BOOST_STATIC_ASSERT
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/openflow/examples/openflow-switch.cc ns-3.38/src/openflow/examples/openflow-switch.cc
--- ns-3.37/src/openflow/examples/openflow-switch.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/openflow/examples/openflow-switch.cc	2023-03-16 20:54:23.812869000 -0700
@@ -51,21 +51,21 @@
 ns3::Time timeout = ns3::Seconds(0);
 
 bool
-SetVerbose(std::string value)
+SetVerbose(const std::string& value)
 {
     verbose = true;
     return true;
 }
 
 bool
-SetDrop(std::string value)
+SetDrop(const std::string& value)
 {
     use_drop = true;
     return true;
 }
 
 bool
-SetTimeout(std::string value)
+SetTimeout(const std::string& value)
 {
     try
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/point-to-point/examples/main-attribute-value.cc ns-3.38/src/point-to-point/examples/main-attribute-value.cc
--- ns-3.37/src/point-to-point/examples/main-attribute-value.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/point-to-point/examples/main-attribute-value.cc	2023-03-16 20:54:23.812869000 -0700
@@ -153,4 +153,6 @@
     NS_LOG_INFO("5.  txQueue limit changed through wildcarded namespace: " << limit.Get());
 
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/point-to-point/model/ppp-header.cc ns-3.38/src/point-to-point/model/ppp-header.cc
--- ns-3.37/src/point-to-point/model/ppp-header.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/point-to-point/model/ppp-header.cc	2023-03-16 20:54:23.816869300 -0700
@@ -100,7 +100,7 @@
 }
 
 uint16_t
-PppHeader::GetProtocol()
+PppHeader::GetProtocol() const
 {
     return m_protocol;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/point-to-point/model/ppp-header.h ns-3.38/src/point-to-point/model/ppp-header.h
--- ns-3.37/src/point-to-point/model/ppp-header.h	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/point-to-point/model/ppp-header.h	2023-03-16 20:54:23.816869300 -0700
@@ -93,7 +93,7 @@
      *
      * \return the protocol type being carried
      */
-    uint16_t GetProtocol();
+    uint16_t GetProtocol() const;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/point-to-point-layout/model/point-to-point-dumbbell.cc ns-3.38/src/point-to-point-layout/model/point-to-point-dumbbell.cc
--- ns-3.37/src/point-to-point-layout/model/point-to-point-dumbbell.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/point-to-point-layout/model/point-to-point-dumbbell.cc	2023-03-16 20:54:23.812869000 -0700
@@ -219,7 +219,7 @@
 PointToPointDumbbellHelper::BoundingBox(double ulx,
                                         double uly, // Upper left x/y
                                         double lrx,
-                                        double lry) // Lower right x/y
+                                        double lry) const // Lower right x/y
 {
     double xDist;
     double yDist;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/point-to-point-layout/model/point-to-point-dumbbell.h ns-3.38/src/point-to-point-layout/model/point-to-point-dumbbell.h
--- ns-3.37/src/point-to-point-layout/model/point-to-point-dumbbell.h	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/point-to-point-layout/model/point-to-point-dumbbell.h	2023-03-16 20:54:23.812869000 -0700
@@ -164,7 +164,7 @@
      * \param lrx lower right x value
      * \param lry lower right y value
      */
-    void BoundingBox(double ulx, double uly, double lrx, double lry);
+    void BoundingBox(double ulx, double uly, double lrx, double lry) const;
 
   private:
     NodeContainer m_leftLeaf;                        //!< Left Leaf nodes
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/examples/jakes-propagation-model-example.cc ns-3.38/src/propagation/examples/jakes-propagation-model-example.cc
--- ns-3.37/src/propagation/examples/jakes-propagation-model-example.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/examples/jakes-propagation-model-example.cc	2023-03-16 20:54:23.816869300 -0700
@@ -28,7 +28,7 @@
 /**
  * \ingroup propagation
  * \brief Constructs a JakesPropagationlossModel and print the loss value as a function of time into
- * std::cout. Distribution and correlation statistics is compared woth a theoretical ones using R
+ * std::cout. Distribution and correlation statistics is compared with a theoretical ones using R
  * package (http://www.r-project.org/). Scripts are presented within comments.
  */
 class JakesPropagationExample
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/model/channel-condition-model.h ns-3.38/src/propagation/model/channel-condition-model.h
--- ns-3.37/src/propagation/model/channel-condition-model.h	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/model/channel-condition-model.h	2023-03-16 20:54:23.816869300 -0700
@@ -103,7 +103,7 @@
     ~ChannelCondition() override;
 
     /**
-     * Get the LosConditionValue contaning the information about the LOS/NLOS
+     * Get the LosConditionValue containing the information about the LOS/NLOS
      * state of the channel
      *
      * \return the LosConditionValue
@@ -119,7 +119,7 @@
     void SetLosCondition(LosConditionValue losCondition);
 
     /**
-     * Get the O2iConditionValue contaning the information about the O2I
+     * Get the O2iConditionValue containing the information about the O2I
      * state of the channel
      *
      * \return the O2iConditionValue
@@ -127,7 +127,7 @@
     O2iConditionValue GetO2iCondition() const;
 
     /**
-     * Set the O2iConditionValue contaning the information about the O2I
+     * Set the O2iConditionValue containing the information about the O2I
      * state of the channel
      *
      * \param o2iCondition the O2iConditionValue
@@ -135,7 +135,7 @@
     void SetO2iCondition(O2iConditionValue o2iCondition);
 
     /**
-     * Get the O2iLowHighConditionValue contaning the information about the O2I
+     * Get the O2iLowHighConditionValue containing the information about the O2I
      * building penetration losses (low or high)
      *
      * \return the O2iLowHighConditionValue
@@ -143,7 +143,7 @@
     O2iLowHighConditionValue GetO2iLowHighCondition() const;
 
     /**
-     * Set the O2iLowHighConditionValue contaning the information about the O2I
+     * Set the O2iLowHighConditionValue containing the information about the O2I
      * building penetration losses (low or high)
      *
      * \param o2iLowHighCondition the O2iLowHighConditionValue
@@ -569,8 +569,8 @@
     Time m_updatePeriod;       //!< the update period for the channel condition
 
     double m_o2iThreshold{
-        0}; //!< the threshold for determing what is the ratio of channels with O2I
-    double m_o2iLowLossThreshold{0}; //!< the threshold for determing what is the ratio of low -
+        0}; //!< the threshold for determining what is the ratio of channels with O2I
+    double m_o2iLowLossThreshold{0}; //!< the threshold for determining what is the ratio of low -
                                      //!< high O2I building penetration losses
     double m_linkO2iConditionToAntennaHeight{
         false}; //!< the indicator that determines whether the O2I/O2O condition is determined based
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/model/cost231-propagation-loss-model.cc ns-3.38/src/propagation/model/cost231-propagation-loss-model.cc
--- ns-3.37/src/propagation/model/cost231-propagation-loss-model.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/model/cost231-propagation-loss-model.cc	2023-03-16 20:54:23.816869300 -0700
@@ -86,7 +86,7 @@
 }
 
 double
-Cost231PropagationLossModel::GetShadowing()
+Cost231PropagationLossModel::GetShadowing() const
 {
     return m_shadowing;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/model/cost231-propagation-loss-model.h ns-3.38/src/propagation/model/cost231-propagation-loss-model.h
--- ns-3.37/src/propagation/model/cost231-propagation-loss-model.h	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/model/cost231-propagation-loss-model.h	2023-03-16 20:54:23.816869300 -0700
@@ -120,7 +120,7 @@
      * Get the shadowing value
      * \returns the shadowing value
      */
-    double GetShadowing();
+    double GetShadowing() const;
     /**
      * Set the shadowing value
      * \param shadowing the shadowing value
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/model/probabilistic-v2v-channel-condition-model.h ns-3.38/src/propagation/model/probabilistic-v2v-channel-condition-model.h
--- ns-3.37/src/propagation/model/probabilistic-v2v-channel-condition-model.h	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/model/probabilistic-v2v-channel-condition-model.h	2023-03-16 20:54:23.816869300 -0700
@@ -75,10 +75,7 @@
      */
     double ComputePnlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
 
-    enum VehicleDensity m_densityUrban
-    {
-        VehicleDensity::INVALID
-    }; //!< vehicle density
+    VehicleDensity m_densityUrban{VehicleDensity::INVALID}; //!< vehicle density
 };
 
 /**
@@ -130,10 +127,7 @@
      */
     double ComputePnlos(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
 
-    enum VehicleDensity m_densityHighway
-    {
-        VehicleDensity::INVALID
-    }; //!< vehicle density
+    VehicleDensity m_densityHighway{VehicleDensity::INVALID}; //!< vehicle density
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/test/channel-condition-model-test-suite.cc ns-3.38/src/propagation/test/channel-condition-model-test-suite.cc
--- ns-3.37/src/propagation/test/channel-condition-model-test-suite.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/test/channel-condition-model-test-suite.cc	2023-03-16 20:54:23.816869300 -0700
@@ -69,13 +69,13 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         Vector m_positionA; //!< the position of the first node
         Vector m_positionB; //!< the position of the second node
         double m_pLos;      //!< LOS probability
         TypeId m_typeId;    //!< the type ID of the channel condition model to be used
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors;          //!< array containing all the test vectors
     Ptr<ThreeGppChannelConditionModel> m_condModel; //!< the channel condition model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/test/propagation-loss-model-test-suite.cc ns-3.38/src/propagation/test/propagation-loss-model-test-suite.cc
--- ns-3.37/src/propagation/test/propagation-loss-model-test-suite.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/test/propagation-loss-model-test-suite.cc	2023-03-16 20:54:23.816869300 -0700
@@ -53,13 +53,13 @@
     void DoRun() override;
 
     /// Test vector
-    typedef struct
+    struct TestVector
     {
         Vector m_position;  //!< Test node position
         double m_pt;        //!< Tx power [dBm]
         double m_pr;        //!< Rx power [W]
         double m_tolerance; //!< Tolerance
-    } TestVector;
+    };
 
     /// Test vectors
     TestVectors<TestVector> m_testVectors;
@@ -164,13 +164,13 @@
     void DoRun() override;
 
     /// Test vector
-    typedef struct
+    struct TestVector
     {
         Vector m_position;  //!< Test node position
         double m_pt;        //!< Tx power [dBm]
         double m_pr;        //!< Rx power [W]
         double m_tolerance; //!< Tolerance
-    } TestVector;
+    };
 
     /// Test vectors
     TestVectors<TestVector> m_testVectors;
@@ -304,13 +304,13 @@
     void DoRun() override;
 
     /// Test vector
-    typedef struct
+    struct TestVector
     {
         Vector m_position;  //!< Test node position
         double m_pt;        //!< Tx power [dBm]
         double m_pr;        //!< Rx power [W]
         double m_tolerance; //!< Tolerance
-    } TestVector;
+    };
 
     /// Test vectors
     TestVectors<TestVector> m_testVectors;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc ns-3.38/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc
--- ns-3.37/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/propagation/test/three-gpp-propagation-loss-model-test-suite.cc	2023-03-16 20:54:23.816869300 -0700
@@ -63,14 +63,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -226,14 +226,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -389,14 +389,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -546,14 +546,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -720,14 +720,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS/NLOSv, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -879,14 +879,14 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         double m_distance;  //!< 2D distance between UT and BS in meters
         bool m_isLos;       //!< if true LOS/NLOSv, if false NLOS
         double m_frequency; //!< carrier frequency in Hz
         double m_pt;        //!< transmitted power in dBm
         double m_pr;        //!< received power in dBm
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     double m_tolerance;                    //!< tolerance
@@ -1020,7 +1020,7 @@
      *        to be used
      * \param hBs the BS height in meters
      * \param hUt the UT height in meters
-     * \param distance the intial distance between the BS and the UT
+     * \param distance the initial distance between the BS and the UT
      * \param shadowingEnabled true if shadowging must be enabled
      */
     void RunTest(uint16_t testNum,
@@ -1047,7 +1047,7 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         std::string m_propagationLossModelType; //!< the propagation loss model type id
         double m_hBs;                           //!< the BS height in meters
@@ -1057,7 +1057,7 @@
                                   //!< case in dB
         double m_shadowingStdNlos; //!< the standard deviation of the shadowing component in the
                                    //!< NLOS case in dB
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors;         //!< array containing all the test vectors
     Ptr<ThreeGppPropagationLossModel> m_lossModel; //!< the propagation loss model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc
--- ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc	2022-11-01 17:37:24.703395600 -0700
+++ ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc	2023-03-16 20:54:23.816869300 -0700
@@ -31,14 +31,14 @@
 using namespace ns3;
 
 static void
-dataSentMacConfirm(McpsDataConfirmParams params)
+DataSentMacConfirm(Ptr<LrWpanNetDevice> device, McpsDataConfirmParams params)
 {
     // In the case of transmissions with the Ack flag activated, the transaction is only
     // successful if the Ack was received.
     if (params.m_status == LrWpanMcpsDataConfirmStatus::IEEE_802_15_4_SUCCESS)
     {
-        NS_LOG_UNCOND("**********" << Simulator::Now().As(Time::S)
-                                   << " | Transmission successfully sent");
+        std::cout << Simulator::Now().As(Time::S) << " | Node " << device->GetNode()->GetId()
+                  << " | Transmission successfully sent\n";
     }
 }
 
@@ -53,12 +53,11 @@
 
     if (verbose)
     {
-        LogComponentEnableAll(LOG_PREFIX_TIME);
-        LogComponentEnableAll(LOG_PREFIX_FUNC);
+        LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC | LOG_PREFIX_NODE));
         LogComponentEnable("LrWpanMac", LOG_LEVEL_INFO);
         LogComponentEnable("LrWpanCsmaCa", LOG_LEVEL_INFO);
         LogComponentEnable("LrWpanHelper", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_INFO);
+        LogComponentEnable("Ping", LOG_LEVEL_INFO);
     }
 
     NodeContainer nodes;
@@ -89,15 +88,13 @@
     Ptr<LrWpanNetDevice> dev1 = lrwpanDevices.Get(0)->GetObject<LrWpanNetDevice>();
     Ptr<LrWpanNetDevice> dev2 = lrwpanDevices.Get(1)->GetObject<LrWpanNetDevice>();
 
-    McpsDataConfirmCallback cb1;
-    cb1 = MakeCallback(&dataSentMacConfirm);
-    dev1->GetMac()->SetMcpsDataConfirmCallback(cb1);
-    dev2->GetMac()->SetMcpsDataConfirmCallback(cb1);
+    dev1->GetMac()->SetMcpsDataConfirmCallback(MakeBoundCallback(&DataSentMacConfirm, dev1));
 
-    // Fake PAN association, coordinator assignment, short address assignment and initialization
+    dev2->GetMac()->SetMcpsDataConfirmCallback(MakeBoundCallback(&DataSentMacConfirm, dev2));
+
+    // Manual PAN association, coordinator assignment, short address assignment and initialization
     // of beacon-enabled mode in 802.15.4-2011.
-    // This is needed because the lr-wpan module does not provide (yet)
-    // a full PAN association procedure.
+    // Association using the MAC functions can also be used instead of a manual association.
 
     // AssociateToBeaconPan (devices, PAN ID, Coordinator Address, Beacon Order, Superframe Order)
 
@@ -113,7 +110,22 @@
     //                            Beacon Interval = 251.65 secs
     //   |-----------------------------------------------------------------------------------------|
 
-    lrWpanHelper.AssociateToBeaconPan(lrwpanDevices, 0, Mac16Address("00:01"), 14, 13);
+    // Manually set an associated PAN, Pan id = 1 the first device (dev1) is used as coordinator
+    lrWpanHelper.CreateAssociatedPan(lrwpanDevices, 5);
+
+    // Start the beacon mode from the MAC layer of the coordinator (dev1)
+    MlmeStartRequestParams params;
+    params.m_panCoor = true;
+    params.m_PanId = 5;
+    params.m_bcnOrd = 14;
+    params.m_sfrmOrd = 13;
+    params.m_logCh = 11;
+
+    Simulator::ScheduleWithContext(dev1->GetNode()->GetId(),
+                                   Seconds(0),
+                                   &LrWpanMac::MlmeStartRequest,
+                                   dev1->GetMac(),
+                                   params);
 
     InternetStackHelper internetv6;
     internetv6.Install(nodes);
@@ -129,30 +141,29 @@
     // Send ping packets after the 2nd second of the simulation during the
     // first 8 seconds of the CAP in the incoming superframe
 
-    uint32_t packetSize = 10;
+    uint32_t packetSize = 16;
     uint32_t maxPacketCount = 5;
     Time interPacketInterval = Seconds(1);
-    Ping6Helper ping6;
+    PingHelper ping(deviceInterfaces.GetAddress(1, 1));
 
-    ping6.SetLocal(deviceInterfaces.GetAddress(0, 1));
-    ping6.SetRemote(deviceInterfaces.GetAddress(1, 1));
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(nodes.Get(0));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(nodes.Get(0));
 
     apps.Start(Seconds(2.0));
-    apps.Stop(Seconds(10.0));
+    apps.Stop(Seconds(7.0));
 
     AsciiTraceHelper ascii;
     lrWpanHelper.EnableAsciiAll(ascii.CreateFileStream("Ping-6LoW-lr-wpan-beacon.tr"));
     lrWpanHelper.EnablePcapAll(std::string("Ping-6LoW-lr-wpan-beacon"), true);
 
-    Simulator::Stop(Seconds(600));
+    Simulator::Stop(Seconds(7));
 
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
 
 // BO/SO values to time equivalence
